﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="ProdcutsApp.WebForm1" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <telerik:RadScriptManager runat="server" ID="RadScriptManager1"></telerik:RadScriptManager>
            <telerik:RadCodeBlock runat="server" ID="RadCodeBlock1">
                <script>

                    var updatedIDs = [], deletedIDs = [];

                    function requestStart(sender, args) {
                        var type = args.get_type();
                        var transport = sender.get_dataSourceObject().options.transport;
                        switch (type) {
                            case "read":
                                var textBox = $find('<%= RadNumericTextBox1.ClientID %>');
                                var value = textBox.get_value();
                                transport.read.url = "api/products/" + value;
                                break;

                            case "create":
                                transport.create.url = "api/products/";
                                break;

                            case "update":
                                transport.update.url = "api/products/" + updatedIDs.shift();
                                break;

                            case "destroy":
                                transport.destroy.url = "api/products/" + deletedIDs.shift();
                                break;

                            default: break;
                        }
                    }
                    function btnClick(sender, args) {
                        var grid = $find('<%= RadGrid1.ClientID %>');
                        grid.get_masterTableView().rebind();
                    }

                    function dataSourceCommand(sender, args) {
                        var commandName = args.get_commandName();
                        var id = args.get_commandArgument().id;
                        switch (commandName) {
                            case "update":
                                updatedIDs.push(id);
                                break;

                            case "remove":
                                deletedIDs.push(id);
                                break;

                            default: break;
                        }
                    }

                </script>
            </telerik:RadCodeBlock>
            <telerik:RadNumericTextBox runat="server" ID="RadNumericTextBox1" Label="Filter by ID: " LabelWidth="65px"></telerik:RadNumericTextBox>
            <telerik:RadButton AutoPostBack="false" runat="server" ID="RadButton1" Text="Filter" OnClientClicked="btnClick"></telerik:RadButton>
            <br />
            <br />
            <telerik:RadGrid AllowFilteringByColumn="true" AllowSorting="true" AllowPaging="true" runat="server" ID="RadGrid1" AutoGenerateColumns="false"
                ClientDataSourceID="RadClientDataSource1">
                <MasterTableView EditMode="Batch" CommandItemDisplay="Top" ClientDataKeyNames="ID">
                    <Columns>
                        <telerik:GridBoundColumn UniqueName="ID" DataField="ID" HeaderText="ID" ReadOnly="true" />
                        <telerik:GridBoundColumn UniqueName="Name" DataField="Name" HeaderText="Name" />
                        <telerik:GridTemplateColumn UniqueName="Category" HeaderText="Category">
                            <ClientItemTemplate>
                                <span>#=Category #</span>
                            </ClientItemTemplate>
                            <EditItemTemplate>
                            <telerik:RadDropDownList runat="server" ID="CategoryIDDropDown">
                                <Items>
                                    <telerik:DropDownListItem Text="Category1" Value="Category1" />
                                    <telerik:DropDownListItem Text="Category2" Value="Category2" />
                                    <telerik:DropDownListItem Text="Category3" Value="Category3" />
                                    <telerik:DropDownListItem Text="Category4" Value="Category4" />
                                </Items>
                            </telerik:RadDropDownList>
                        </EditItemTemplate>
                        </telerik:GridTemplateColumn>
                        <telerik:GridBoundColumn UniqueName="Price" DataField="Price" HeaderText="Price" />
                        <telerik:GridClientDeleteColumn HeaderText="Delete" ButtonType="ImageButton" HeaderStyle-Width="70px">
                        </telerik:GridClientDeleteColumn>
                    </Columns>
                </MasterTableView>
            </telerik:RadGrid>
            <telerik:RadClientDataSource runat="server" ID="RadClientDataSource1">
                <ClientEvents OnCommand="dataSourceCommand" OnRequestStart="requestStart" />
                <DataSource>
                    <WebServiceDataSourceSettings>
                        <Select Url="api/products" RequestType="Get" />
                        <Insert Url="api/products" RequestType="Post" />
                        <Update Url="api/products" RequestType="Put" />
                        <Delete Url="api/products" RequestType="Delete" />
                    </WebServiceDataSourceSettings>
                </DataSource>
                <Schema>
                    <Model ID="ID">
                        <telerik:ClientDataSourceModelField FieldName="ID" DataType="Number" />
                        <telerik:ClientDataSourceModelField FieldName="Name" DataType="String" />
                        <telerik:ClientDataSourceModelField FieldName="Category" DataType="String" />
                        <telerik:ClientDataSourceModelField FieldName="Price" DataType="Number" />
                    </Model>
                </Schema>
            </telerik:RadClientDataSource>

        </div>
    </form>
</body>
</html>
